Index: /trunk/lib/FlairSimulator/src/Model_impl.cpp
===================================================================
--- /trunk/lib/FlairSimulator/src/Model_impl.cpp	(revision 213)
+++ /trunk/lib/FlairSimulator/src/Model_impl.cpp	(revision 214)
@@ -25,5 +25,5 @@
 #include "SpinBox.h"
 #include "CheckBox.h"
-#include "cvmatrix.h"
+#include "Matrix.h"
 #include "Euler.h"
 #include <math.h>
@@ -134,5 +134,5 @@
   desc->SetElementName(17, 0, "my");
   desc->SetElementName(18, 0, "mz");
-  output = new cvmatrix(this, desc, floatType, "state");
+  output = new Matrix(this, desc, floatType, "state");
   delete desc;
 
Index: /trunk/lib/FlairSimulator/src/SimuLaserGL.cpp
===================================================================
--- /trunk/lib/FlairSimulator/src/SimuLaserGL.cpp	(revision 213)
+++ /trunk/lib/FlairSimulator/src/SimuLaserGL.cpp	(revision 214)
@@ -20,5 +20,5 @@
 #include "Model.h"
 #include "Gui.h"
-#include <cvmatrix.h>
+#include <Matrix.h>
 #include <SharedMem.h>
 #include <TabWidget.h>
Index: /trunk/lib/FlairSimulator/src/SimuUsGL.cpp
===================================================================
--- /trunk/lib/FlairSimulator/src/SimuUsGL.cpp	(revision 213)
+++ /trunk/lib/FlairSimulator/src/SimuUsGL.cpp	(revision 214)
@@ -17,5 +17,5 @@
 #include "SimuUsGL.h"
 #include "Model.h"
-#include <cvmatrix.h>
+#include <Matrix.h>
 #include <SharedMem.h>
 #include <TabWidget.h>
@@ -54,5 +54,5 @@
 #endif
     // todo: utiliser le placement de l'us dans le drone et sa portée
-    cvmatrix *input = (cvmatrix *)data;
+    Matrix *input = (Matrix *)data;
     value = input->Value(9, 0);
     shmem->Write((char *)&value, sizeof(float));
Index: /trunk/lib/FlairSimulator/src/X4.cpp
===================================================================
--- /trunk/lib/FlairSimulator/src/X4.cpp	(revision 213)
+++ /trunk/lib/FlairSimulator/src/X4.cpp	(revision 214)
@@ -20,4 +20,5 @@
 #include <Tab.h>
 #include <DoubleSpinBox.h>
+#include <SpinBox.h>
 #include <GroupBox.h>
 #include <math.h>
@@ -73,4 +74,6 @@
   j_yaw = new DoubleSpinBox(setup_tab->LastRowLastCol(), "j_yaw:", 0, 1, 0.001,
                             5); // moment d'inertie d'un axe (N.m.s²/rad)
+                            
+  motorTimeout = new SpinBox(setup_tab->NewRow(), "motor timeout:","ms", 0, 1000, 100,100);
 
   motors = new SimuBldc(this, name, 4, modelId,0);
@@ -199,11 +202,22 @@
   float fl_speed, fr_speed, rl_speed, rr_speed;
   float u_roll, u_pitch, u_yaw, u_thrust;
+  Time motorTime;
 #ifdef GL
   motor_speed_mutex->GetMutex();
 #endif // GL
-  motors->GetSpeeds(motor_speed);
+  motors->GetSpeeds(motor_speed,&motorTime);
+  if((GetTime()-motorTime)/1000000>motorTimeout->Value()) {
+    for(int i=0;i<4;i++) {
+      if(motor_speed[i]!=0) {
+         //Printf("timout\n");
+        for(int i=0;i<4;i++) motor_speed[i]=0;
+        break;
+      }
+    }
+  }
 #ifdef GL
   motor_speed_mutex->ReleaseMutex();
 #endif // GL
+  
   fl_speed = motor_speed[0];
   fr_speed = motor_speed[1];
@@ -212,9 +226,9 @@
 
   /*
-      ** ===================================================================
-      **    u roll: roll torque
-      **
-      ** ===================================================================
-      */
+  ** ===================================================================
+  **    u roll: roll torque
+  **
+  ** ===================================================================
+  */
   u_roll = arm_length->Value() * k_mot->Value() *
            (fl_speed * fl_speed + rl_speed * rl_speed - fr_speed * fr_speed -
Index: /trunk/lib/FlairSimulator/src/X4.h
===================================================================
--- /trunk/lib/FlairSimulator/src/X4.h	(revision 213)
+++ /trunk/lib/FlairSimulator/src/X4.h	(revision 214)
@@ -26,4 +26,5 @@
 namespace gui {
 class DoubleSpinBox;
+class SpinBox;
 }
 namespace actuator {
@@ -63,4 +64,5 @@
   gui::DoubleSpinBox *f_air_vert, *f_air_lat;
   gui::DoubleSpinBox *j_roll, *j_pitch, *j_yaw;
+  gui::SpinBox *motorTimeout;
 };
 } // end namespace simulator
Index: /trunk/lib/FlairSimulator/src/X8.cpp
===================================================================
--- /trunk/lib/FlairSimulator/src/X8.cpp	(revision 213)
+++ /trunk/lib/FlairSimulator/src/X8.cpp	(revision 214)
@@ -20,4 +20,5 @@
 #include <Tab.h>
 #include <DoubleSpinBox.h>
+#include <SpinBox.h>
 #include <GroupBox.h>
 #include <math.h>
@@ -81,4 +82,6 @@
       setup_tab->LastRowLastCol(), "S:", 1, 2,
       0.1); // coefficient de forme des helices 1<S=1+Ss/Sprop<2 (sans unite)
+      
+  motorTimeout = new SpinBox(setup_tab->NewRow(), "motor timeout:","ms", 0, 1000, 100,100);
 
   motors = new SimuBldc(this, name, 8, modelId,0);
@@ -231,8 +234,18 @@
   float u_roll, u_pitch, u_yaw, u_thrust;
   float omega;
+  Time motorTime;
 #ifdef GL
   motor_speed_mutex->GetMutex();
 #endif // GL
-  motors->GetSpeeds(motor_speed);
+  motors->GetSpeeds(motor_speed,&motorTime);
+  if((GetTime()-motorTime)/1000000>motorTimeout->Value()) {
+    for(int i=0;i<8;i++) {
+      if(motor_speed[i]!=0) {
+         //Printf("timout\n");
+        for(int i=0;i<8;i++) motor_speed[i]=0;
+        break;
+      }
+    }
+  }
 #ifdef GL
   motor_speed_mutex->ReleaseMutex();
Index: /trunk/lib/FlairSimulator/src/X8.h
===================================================================
--- /trunk/lib/FlairSimulator/src/X8.h	(revision 213)
+++ /trunk/lib/FlairSimulator/src/X8.h	(revision 214)
@@ -26,4 +26,5 @@
 namespace gui {
 class DoubleSpinBox;
+class SpinBox;
 }
 namespace actuator {
@@ -65,4 +66,5 @@
   gui::DoubleSpinBox *j_roll, *j_pitch, *j_yaw;
   gui::DoubleSpinBox *j_r, *sigma, *S;
+  gui::SpinBox *motorTimeout;
 };
 } // end namespace simulator
Index: /trunk/lib/FlairSimulator/src/unexported/Model_impl.h
===================================================================
--- /trunk/lib/FlairSimulator/src/unexported/Model_impl.h	(revision 213)
+++ /trunk/lib/FlairSimulator/src/unexported/Model_impl.h	(revision 214)
@@ -25,5 +25,5 @@
 namespace flair {
 namespace core {
-class cvmatrix;
+class Matrix;
 class Mutex;
 class ConditionVariable;
@@ -101,5 +101,5 @@
   flair::gui::CheckBox *enable_opti;
   flair::simulator::Model *self;
-  flair::core::cvmatrix *output;
+  flair::core::Matrix *output;
   flair::core::Mutex *states_mutex;
 
Index: /trunk/lib/FlairVisionFilter/src/HoughLines.cpp
===================================================================
--- /trunk/lib/FlairVisionFilter/src/HoughLines.cpp	(revision 213)
+++ /trunk/lib/FlairVisionFilter/src/HoughLines.cpp	(revision 214)
@@ -14,5 +14,5 @@
 #include "HoughLines.h"
 #include <cvimage.h>
-#include <cvmatrix.h>
+#include <Matrix.h>
 #include <Layout.h>
 #include <GroupBox.h>
@@ -49,5 +49,5 @@
     desc->SetElementName(2,0,"orientation deg");
     desc->SetElementName(3,0,"line_detected");
-    output=new cvmatrix(this,desc,floatType,name);
+    output=new Matrix(this,desc,floatType,name);
     delete desc;
 
@@ -90,5 +90,5 @@
 }
 
-cvmatrix *HoughLines::Output(void) const {
+Matrix *HoughLines::Output(void) const {
     return output;
 }
Index: /trunk/lib/FlairVisionFilter/src/HoughLines.h
===================================================================
--- /trunk/lib/FlairVisionFilter/src/HoughLines.h	(revision 213)
+++ /trunk/lib/FlairVisionFilter/src/HoughLines.h	(revision 214)
@@ -17,5 +17,5 @@
     namespace core {
         class cvimage;
-        class cvmatrix;
+        class Matrix;
     }
     namespace gui {
@@ -56,5 +56,5 @@
             float GetOrientation(void) const;
             float GetDistance(void) const;
-            core::cvmatrix *Output(void) const;
+            core::Matrix *Output(void) const;
 
         private:
@@ -69,5 +69,5 @@
             float distance,orientation;
             CvMat* linesStorage;
-            core::cvmatrix *output;
+            core::Matrix *output;
     };
 } // end namespace filter
Index: /trunk/lib/FlairVisionFilter/src/OpticalFlowSpeed.cpp
===================================================================
--- /trunk/lib/FlairVisionFilter/src/OpticalFlowSpeed.cpp	(revision 213)
+++ /trunk/lib/FlairVisionFilter/src/OpticalFlowSpeed.cpp	(revision 214)
@@ -14,5 +14,5 @@
 #include "OpticalFlowSpeed.h"
 #include "OpticalFlowData.h"
-#include <cvmatrix.h>
+#include <Matrix.h>
 #include <Object.h>
 
@@ -30,5 +30,5 @@
   desc->SetElementName(0,0,"vx");
   desc->SetElementName(1,0,"vy");
-  output=new cvmatrix(this,desc,floatType,name);
+  output=new Matrix(this,desc,floatType,name);
   delete desc;
 
@@ -81,5 +81,5 @@
 }
 
-core::cvmatrix *OpticalFlowSpeed::Output() const
+core::Matrix *OpticalFlowSpeed::Output() const
 {
     return output;
Index: /trunk/lib/FlairVisionFilter/src/OpticalFlowSpeed.h
===================================================================
--- /trunk/lib/FlairVisionFilter/src/OpticalFlowSpeed.h	(revision 213)
+++ /trunk/lib/FlairVisionFilter/src/OpticalFlowSpeed.h	(revision 214)
@@ -17,5 +17,5 @@
     namespace core
     {
-        class cvmatrix;
+        class Matrix;
     }
 }
@@ -71,5 +71,5 @@
             * Second line is speed along y axis. \n
             */
-            core::cvmatrix *Output() const;
+            core::Matrix *Output() const;
 
         private:
@@ -83,5 +83,5 @@
             void UpdateFrom(const core::io_data *data);
 
-            core::cvmatrix *output;
+            core::Matrix *output;
     };
 } // end namespace filter
Index: /trunk/tools/Controller/DualShock3/src/DualShock3.cpp
===================================================================
--- /trunk/tools/Controller/DualShock3/src/DualShock3.cpp	(revision 213)
+++ /trunk/tools/Controller/DualShock3/src/DualShock3.cpp	(revision 214)
@@ -18,5 +18,5 @@
 #include "DualShock3.h"
 #include <Controller.h>
-#include <cvmatrix.h>
+#include <Matrix.h>
 #include <Tab.h>
 #include <TabWidget.h>
@@ -96,5 +96,5 @@
     axisDescriptor->SetElementName(i, 0, GetAxisDescription(i));
   }
-  axis = new cvmatrix((IODevice *)this, axisDescriptor, Int16Type);
+  axis = new Matrix((IODevice *)this, axisDescriptor, Int16Type);
   delete axisDescriptor;
   AddDataToLog(axis);
@@ -107,5 +107,5 @@
     buttonDescriptor->SetElementName(i, 0, GetButtonDescription(i));
   }
-  button = new cvmatrix((IODevice *)this, buttonDescriptor, Int8Type);
+  button = new Matrix((IODevice *)this, buttonDescriptor, Int8Type);
   AddDataToLog(button);
 
Index: /trunk/tools/FlairGCS/src/file_ui.cpp
===================================================================
--- /trunk/tools/FlairGCS/src/file_ui.cpp	(revision 213)
+++ /trunk/tools/FlairGCS/src/file_ui.cpp	(revision 214)
@@ -193,4 +193,12 @@
         uint8_t *value = (uint8_t *)(data + offset);
         offset += sizeof(uint8_t);
+        out << "," << *value;
+      } else if (data_type.at(i) == "int16_t)") {
+        int16_t *value = (int16_t *)(data + offset);
+        offset += sizeof(int16_t);
+        out << "," << *value;
+      } else if (data_type.at(i) == "uint16_t)") {
+        uint16_t *value = (uint16_t *)(data + offset);
+        offset += sizeof(uint16_t);
         out << "," << *value;
       } else {
